version: "3.9"
services:
  openmvg:
    build:
      context: .
      dockerfile: DockerfileOpenMVG
    networks:
      - default
    ports:
      - "5000:5000"
    environment:
      - OTEL_EXPORTER_OTLP_ENDPOINT=otel-collector:4317
      - INSTALL_MODE=SERVER
      - OPENMVS_URL=http://openmvs:5000
      - DB_HOST=mariadb
      - DB_PORT=3306
    volumes:
      - ./download:/usr/src/app/download
#    depends_on:
#      - mariadb
  openmvs:
    build: 
      context: .
      dockerfile: DockerfileOpenMVS
    networks:
      - default
    ports:
      - "5001:5000"
    environment:
      - OTEL_EXPORTER_OTLP_ENDPOINT=otel-collector:4317
      - INSTALL_MODE=SERVER
    volumes:
      - ./download:/usr/src/app/download
    
  viewer:
    build: 
      context: .
      dockerfile: DockerfileViewer
    networks:
      - default
    ports:
      - "5002:5000"
    environment:
      - OTEL_EXPORTER_OTLP_ENDPOINT=otel-collector:4317
      - OPENMVG_URL=http://openmvg:5000
    volumes:
      - ./download:/usr/src/app/download

  otel-collector:
    image: otel/opentelemetry-collector-contrib
    command: ["--config=/etc/otel-collector-config.yml"]
    volumes:
      - ./config/otel-collector-config.yml:/etc/otel-collector-config.yml
    ports:
      - "1888:1888"   # pprof extension
      - "8888:8888"   # Prometheus metrics exposed by the collector
      - "8889:8889"   # Prometheus exporter metrics
      - "13133:13133" # health_check extension
      - "4317:4317"   # OTLP gRPC receiver
#      - "55679:55679" # zpages extension
    depends_on:
      - jaeger

  jaeger:
    image: jaegertracing/all-in-one:latest
    ports:
      - "16686:16686"
      - "14250"      

  mariadb:
    image: mariadb:latest
    environment:
      - MARIADB_ROOT_PASSWORD=Password123!
    volumes:
     - ./helm-chart/configs/mariadb.sql:/docker-entrypoint-initdb.d/mariadb.sql
    ports:
     - "3306:3306"

networks:
  default: